addpath('/home/jgillis/programs/optistack/src')

N = 30;  % Control discretization
T = 3.0; % End time

% System dynamics
f = @(x,u) (1 - x)*x  + u;

% Declare optimization variables
X  = optivar(N+1);  % states
U  = optivar(N);    % control

% Collection of constraints
constr = {};

% Objective function
obj = 0;

for k = 1:N
    % Propagate state
    x_next = rk4(f,T/N,X(k),U(k));
    
    % Gap closing constraint
    constr = {constr{:}, X(k+1) == x_next};
    
    % Construct an objective
    obj = obj + x_next^2 + U(k)^2;
end

% Boundary constraint
x0 = 4;
constr = {constr{:} X(1) == x0, X(end) == 0};

%constr = {constr{:} X(N/3:2*N/3) >= 3 };

sol = optisolve(obj, constr);

hold on
plot(optival(X),'linewidth',2)
stairs(optival(U),'r','linewidth',2)
legend('state','control')
grid on