addpath('/home/jgillis/programs/optistack/src')

N = 30;  % Control discretization
T = 3.0; % End time

% Declare optimization variables
U  = optivar(N);    % control
X  = optivar(N+1);  % states

% System dynamics
f = @(x,u) (1 - x)*x  + u;

% Collection of constraints
constr = {};

% Objective function
obj = 0;

for i = 1:N
    % Propagate state
    x_next = rk4(f,T/N,X(i),U(i));
    
    % Gap closing constraint
    constr = {constr{:}, X(i+1) == x_next};
    
    % Construct an objective
    obj = obj + x_next^2 + U(i)^2;
end

% Boundary constraint
x0 = optipar();
x0.setValue(4);
constr = {constr{:} X(1) == x0, X(end) == 0};

sol = optisolve(obj, constr);
x0.setValue(1);
sol.resolve();

hold on
plot(optival(X),'linewidth',2)
stairs(optival(U),'r','linewidth',2)
legend('state','control')
grid on